<template>
  <transition :name="transition" :mode="transitionMode">
    <!--
      Loading
      Will be visible when the query is loading. This will be empty when the
      query is loading but "displayLoading" is false. (will be the case when
      using the "delayLoading" prop)
    -->
    <div v-if="query.loading.value" key="loading">
      <slot v-show="displayLoading" name="loading" />
    </div>

    <!--
      Error
      Will be visible when the query resolved in an error
    -->
    <div v-else-if="query.error.value" key="error">
      <slot name="error" />
    </div>

    <!--
      Data
      Will be visible when the query resolved in data
    -->
    <div v-else key="data">
      <slot name="data" />
    </div>
  </transition>
</template>

<script lang="ts">
import { defineComponent, PropType, ref, watch } from '@nuxtjs/composition-api'
import { UseQueryReturn } from '@vue/apollo-composable'

export default defineComponent({
  props: {
    // Query
    query: {
      type: Object as PropType<UseQueryReturn<any, any>>,
      required: true,
    },

    // Delay loading
    // Will delay showing the loading animation until the specified time has passed
    // and will show a empty screen instead
    delayLoading: {
      type: Number as PropType<number>,
      default: 0,
    },

    // Transition between modes
    transition: {
      type: String as PropType<string>,
      default: '',
    },

    // Transition mode
    transitionMode: {
      type: String as PropType<string>,
      default: '',
    },
  },
  setup(props) {
    // Should the loading slot be displayed
    const displayLoading = ref(false)

    // Watch the query
    // If the query switched loading to false, set a timeout to update the displayLoading
    watch(
      () => props.query.loading,
      (loading) => {
        if (loading) {
          setTimeout(() => (displayLoading.value = true), props.delayLoading)
        }
      },
      { immediate: true }
    )

    return {
      displayLoading,
    }
  },
})
</script>
